• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1#/bin/sh
2
3# Script to prepare the files for building a PCRE2 release. It does some
4# processing of the documentation, detrails files, and creates pcre2.h.generic
5# and config.h.generic (for use by builders who can't run ./configure).
6
7# You must run this script before runnning "make dist". If its first argument
8# is "doc", it stops after preparing the documentation. There are no other
9# arguments. The script makes use of the following files:
10
11# 132html     A Perl script that converts a .1 or .3 man page into HTML. It
12#             "knows" the relevant troff constructs that are used in the PCRE2
13#             man pages.
14
15# CheckMan    A Perl script that checks man pages for typos in the mark up.
16
17# CleanTxt    A Perl script that cleans up the output of "nroff -man" by
18#             removing backspaces and other redundant text so as to produce
19#             a readable .txt file.
20
21# Detrail     A Perl script that removes trailing spaces from files.
22
23# doc/index.html.src
24#             A file that is copied as index.html into the doc/html directory
25#             when the HTML documentation is built. It works like this so that
26#             doc/html can be deleted and re-created from scratch.
27
28# README & NON-AUTOTOOLS-BUILD
29#             These files are copied into the doc/html directory, with .txt
30#             extensions so that they can by hyperlinked from the HTML
31#             documentation, because some people just go to the HTML without
32#             looking for text files.
33
34
35# First, sort out the documentation. Remove pcre2demo.3 first because it won't
36# pass the markup check (it is created below, using markup that none of the
37# other pages use).
38
39cd doc
40echo Processing documentation
41
42/bin/rm -f pcre2demo.3
43
44# Check the remaining man pages
45
46perl ../CheckMan *.1 *.3
47if [ $? != 0 ] ; then exit 1; fi
48
49# Make Text form of the documentation. It needs some mangling to make it
50# tidy for online reading. Concatenate all the .3 stuff, but omit the
51# individual function pages.
52
53cat <<End >pcre2.txt
54-----------------------------------------------------------------------------
55This file contains a concatenation of the PCRE2 man pages, converted to plain
56text format for ease of searching with a text editor, or for use on systems
57that do not have a man page processor. The small individual files that give
58synopses of each function in the library have not been included. Neither has
59the pcre2demo program. There are separate text files for the pcre2grep and
60pcre2test commands.
61-----------------------------------------------------------------------------
62
63
64End
65
66echo "Making pcre2.txt"
67for file in pcre2 pcre2api pcre2build pcre2callout pcre2compat pcre2jit \
68            pcre2limits pcre2matching pcre2partial pcre2pattern pcre2perform \
69            pcre2posix pcre2sample pcre2serialize pcre2syntax \
70            pcre2unicode ; do
71  echo "  Processing $file.3"
72  nroff -c -man $file.3 >$file.rawtxt
73  perl ../CleanTxt <$file.rawtxt >>pcre2.txt
74  /bin/rm $file.rawtxt
75  echo "------------------------------------------------------------------------------" >>pcre2.txt
76  if [ "$file" != "pcre2sample" ] ; then
77    echo " " >>pcre2.txt
78    echo " " >>pcre2.txt
79  fi
80done
81
82# The three commands
83for file in pcre2test pcre2grep pcre2-config ; do
84  echo Making $file.txt
85  nroff -c -man $file.1 >$file.rawtxt
86  perl ../CleanTxt <$file.rawtxt >$file.txt
87  /bin/rm $file.rawtxt
88done
89
90
91# Make pcre2demo.3 from the pcre2demo.c source file
92
93echo "Making pcre2demo.3"
94perl <<"END" >pcre2demo.3
95  open(IN, "../src/pcre2demo.c") || die "Failed to open src/pcre2demo.c\n";
96  open(OUT, ">pcre2demo.3") || die "Failed to open pcre2demo.3\n";
97  print OUT ".SH NAME\n" .
98            "// - A demonstration C program for PCRE2 - //\n" .
99            ".sp\n" .
100            ".\\\" Start example.\n" .
101            ".de EX\n" .
102            ".  nr mE \\\\n(.f\n" .
103            ".  nf\n" .
104            ".  nh\n" .
105            ".  ft CW\n" .
106            "..\n" .
107            ".\n" .
108            ".\n" .
109            ".\\\" End example.\n" .
110            ".de EE\n" .
111            ".  ft \\\\n(mE\n" .
112            ".  fi\n" .
113            ".  hy \\\\n(HY\n" .
114            "..\n" .
115            ".\n" .
116            ".EX\n" ;
117  while (<IN>)
118    {
119    s/\\/\\e/g;
120    print OUT;
121    }
122  print OUT ".EE\n";
123  close(IN);
124  close(OUT);
125END
126if [ $? != 0 ] ; then exit 1; fi
127
128
129# Make HTML form of the documentation.
130
131echo "Making HTML documentation"
132/bin/rm html/*
133cp index.html.src html/index.html
134cp ../README html/README.txt
135cp ../NON-AUTOTOOLS-BUILD html/NON-AUTOTOOLS-BUILD.txt
136
137for file in *.1 ; do
138  base=`basename $file .1`
139  echo "  Making $base.html"
140  perl ../132html -toc $base <$file >html/$base.html
141done
142
143# Exclude table of contents for function summaries. It seems that expr
144# forces an anchored regex. Also exclude them for small pages that have
145# only one section.
146
147for file in *.3 ; do
148  base=`basename $file .3`
149  toc=-toc
150  if [ `expr $base : '.*_'` -ne 0 ] ; then toc="" ; fi
151  if [ "$base" = "pcre2sample" ]  || \
152     [ "$base" = "pcre2compat" ]  || \
153     [ "$base" = "pcre2limits" ]  || \
154     [ "$base" = "pcre2unicode" ] ; then
155    toc=""
156  fi
157  echo "  Making $base.html"
158  perl ../132html $toc $base <$file >html/$base.html
159  if [ $? != 0 ] ; then exit 1; fi
160done
161
162# End of documentation processing; stop if only documentation required.
163
164cd ..
165echo Documentation done
166if [ "$1" = "doc" ] ; then exit; fi
167
168# These files are detrailed; do not detrail the test data because there may be
169# significant trailing spaces. Do not detrail RunTest.bat, because it has CRLF
170# line endings and the detrail script removes all trailing white space. The
171# configure files are also omitted from the detrailing.
172
173files="\
174  Makefile.am \
175  configure.ac \
176  README \
177  LICENCE \
178  COPYING \
179  AUTHORS \
180  NEWS \
181  NON-AUTOTOOLS-BUILD \
182  INSTALL \
183  132html \
184  CleanTxt \
185  Detrail \
186  ChangeLog \
187  CMakeLists.txt \
188  RunGrepTest \
189  RunTest \
190  pcre2-config.in \
191  perltest.sh \
192  libpcre2-8.pc.in \
193  libpcre2-16.pc.in \
194  libpcre2-32.pc.in \
195  libpcre2-posix.pc.in \
196  src/pcre2_dftables.c \
197  src/pcre2.h.in \
198  src/pcre2_auto_possess.c \
199  src/pcre2_compile.c \
200  src/pcre2_config.c \
201  src/pcre2_context.c \
202  src/pcre2_convert.c \
203  src/pcre2_dfa_match.c \
204  src/pcre2_error.c \
205  src/pcre2_extuni.c \
206  src/pcre2_find_bracket.c \
207  src/pcre2_internal.h \
208  src/pcre2_intmodedep.h \
209  src/pcre2_jit_compile.c \
210  src/pcre2_jit_match.c \
211  src/pcre2_jit_misc.c \
212  src/pcre2_jit_test.c \
213  src/pcre2_maketables.c \
214  src/pcre2_match.c \
215  src/pcre2_match_data.c \
216  src/pcre2_newline.c \
217  src/pcre2_ord2utf.c \
218  src/pcre2_pattern_info.c \
219  src/pcre2_printint.c \
220  src/pcre2_string_utils.c \
221  src/pcre2_study.c \
222  src/pcre2_substring.c \
223  src/pcre2_tables.c \
224  src/pcre2_ucd.c \
225  src/pcre2_ucp.h \
226  src/pcre2_valid_utf.c \
227  src/pcre2_xclass.c \
228  src/pcre2demo.c \
229  src/pcre2grep.c \
230  src/pcre2posix.c \
231  src/pcre2posix.h \
232  src/pcre2test.c"
233
234echo Detrailing
235perl ./Detrail $files doc/p* doc/html/*
236
237echo Done
238
239#End
240